<template>
  <div class="ui input icon">
    <div class="ui input icon">
      <input
        type="tel"
        :value="phone"
        @keydown="onKeydown"
        @keypress="preventText"
        @input.prevent="onInput"
        v-bind="attrs">
      <i
        class="link advanced icon remove"
        @click="phone = '+7 (9__) ___-__-__'"/>
    </div>
  </div>
</template>

<script>
export default {
  name: 'ConciergePhone',
  inheritAttrs: false,
  props: {
    value: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      phone: '+7 (9__) ___-__-__',
      mask: '+7 (9__) ___-__-__',
      deletingKey: false,
      arrowKey: null,
      lastIndex: 5,
      attrs: {
        placeholder: 'Номер телефона',
      },
    };
  },
  watch: {
    phone(newValue) {
      const regex = /\d/g;
      let match;

      while (match === regex.exec(newValue)) {
        this.lastIndex = regex.lastIndex;
      }

      this.$emit('input', newValue);
    },
    value(newValue) {
      this.phone = newValue;
    },
  },
  created() {
    this.attrs = Object.assign({}, this.attrs, this.$attrs);
    if (this.value) {
      this.phone = this.value;
    }
  },
  mounted() {
    this.setCursorPosition(5);
  },
  methods: {
    setCursorPosition(position) {
      const input = this.$el.querySelector('input');
      const valueLength = input.value.length;

      if (!position) {
        position = valueLength;
      }

      input.focus();
      input.setSelectionRange(position, position);
    },
    onInput(event) {
      const { target } = event;
      let clearValue = target.value.replace(/\D/g, '');
      const cursorPosition = target.selectionStart;
      let i = 0;

      if (!target.value.startsWith('+7 (9')) {
        target.value = this.phone;
        setTimeout(() => {
          this.setCursorPosition(this.lastIndex);
        }, 10);
        return;
      }

      if (this.deletingKey === 46 && (cursorPosition === 7 || cursorPosition === 12 || cursorPosition === 15)) {
        clearValue = this.removeDigitAt(this.phone, cursorPosition + 1).replace(/\D/g, '');
      }

      this.phone = this.mask.replace(/./g, (char) => {
        if (/[_\d]/.test(char) && i < clearValue.length) {
          // eslint-disable-next-line no-plusplus
          return clearValue.charAt(i++);
        }
        return char;
      }).substring(0, 18);

      setTimeout(() => {
        if (!this.deletingKey
          && (cursorPosition === 7 || cursorPosition === 9 || cursorPosition === 12 || cursorPosition === 15)) {
          this.setCursorPosition(cursorPosition + 1);
        } else {
          this.setCursorPosition(cursorPosition);
        }
      }, 0);

      target.value = this.phone;
    },
    onKeydown(e) {
      this.arrowKey = e.which === 37 || e.which === 39;
      this.deletingKey = (e.which === 46 || e.which === 8) ? e.which : false;
    },
    preventText(e) {
      if ((e.which < 48 || e.which > 57) && !this.deletingKey && !this.arrowKey) {
        e.preventDefault();
      }
    },
    removeDigitAt(str, index) {
      let digitIndex = index;

      while (!/\d/.test(str.charAt(digitIndex))) {
        digitIndex += 1;
      }

      return str.substr(0, index) + str.substr(digitIndex + 1);
    },
  },
};
</script>

<style scoped lang="scss">
  .invalid input,
  .invalid .multiselect__tags {
    border-color: #e13c3c !important;
  }
  .helper__input._phone {
    .ui.input {
      width: 100%;
    }
  }
</style>
